var {Promise, map} = require('..'),
	whenWriteFile = Promise.promisify(require('fs').writeFile),
	generate = require('./generate'),
	{dirname, join} = require('path'),
	whenMkDir = Promise.promisify(require('mkdirp'));

module.exports = (options = '.') => {
	if (typeof options === 'string') {
		options = {dir: options};
	}

	var boundGenerate = generate(options);
	var {dir} = options;

	return asts =>
		boundGenerate(asts)
		.then(pairs => map(pairs, vinylPair => Promise.all(Object.keys(vinylPair).map(key => {
			var file = vinylPair[key];

			if (!file) {
				return;
			}

			var path = join(dir, file.path);
			return whenMkDir(dirname(path)).then(() => whenWriteFile(path, file.contents));
		}))))
		.then(() => asts);
};