var {map} = require('..'),
	{generate} = require('escodegen');

module.exports = (options = {}) => {
	options.sourceMapWithCode = true;

	return asts => map.wait(asts, ast => {
		var output = generate(ast.program, options);

		return {
			code: {
				path: ast.loc.source,
				contents: new Buffer(output.code)
			},
			map: output.map && {
				path: ast.loc.source + '.map',
				contents: new Buffer(output.map.toString())
			}
		};
	});
};