var {Promise, map} = require('..'),
	whenReadFile = Promise.promisify(require('fs').readFile),
	whenReadVinyl = path => whenReadFile(path).then(contents => ({path, contents})),
	parse = require('./parse');

module.exports = sources => map(sources, src => {
	if (typeof src === 'string') {
		src = {code: src};
	}

	return Promise.props({
		code: whenReadVinyl(src.code),
		map: src.map && whenReadVinyl(src.map)
	});
}).then(parse);