var gulp = require('gulp');
var es6Transpiler = require('gulp-es6-transpiler');
var mocha = require('gulp-mocha');
var plumber = require('gulp-plumber');

gulp.task('es6-to-es5', function () {
	return gulp
		.src(['index.js', 'builtins/**/*.js', 'test/**/*.js', '!test/fixtures/**/*'], {base: './'})
		.pipe(plumber())
		.pipe(es6Transpiler({
			globals: {
				describe: false,
				it: false
			}
		}))
		.pipe(gulp.dest('es5'));
});

gulp.task('fixtures', function () {
	return gulp
		.src('test/fixtures/**/*', {base: './'})
		.pipe(plumber())
		.pipe(gulp.dest('es5'));
});

gulp.task('default', ['es6-to-es5', 'fixtures'], function () {
	return gulp
		.src('es5/test/builtins/**/*.js')
		.pipe(plumber())
		.pipe(mocha({reporter: 'spec'}));
});

gulp.task('watch', function () {
	gulp.watch(['index.js', 'builtins/**/*.js', 'test/**/*.js'], ['default']);
});